//******************************************
//The net driver version
//Database name= jdbc:db2://<remotehost>:<db2_port_no>/SAMPLE
//For example we use jdbc:db2://rhsrv4.itso.ral.ibm.com:8083/SAMPLE
//************************************************************

import java.sql.*;
import java.io.*;
import java.util.*;

public class DB2net1 {

 static DataInputStream kbd = new DataInputStream(System.in);

 static String url = "jdbc:db2://rdb.translab.cs.sunysb.edu:6789/";
 static String driver = "COM.ibm.db2.jdbc.net.DB2Driver";
 static String login = "";
 static String passwd = "";

 static Connection curConn = null;

 public static void main(String argv[]) throws IOException
 {
  String temp = "";

  System.out.println("SAMPLE DB2 ACCESS (net driver).\n");
  System.out.print("Enter the database name (i.e. c532_001) : ");
  System.out.flush();
  temp = kbd.readLine();
  if (!temp.equals("")) url = url + temp;
  System.out.print("Enter the login (i.e. c532_001) : ");
  System.out.flush();
  temp = kbd.readLine();
  if (!temp.equals("")) login = temp;
  System.out.print("Enter the passwd : ");
  System.out.flush();
  temp = kbd.readLine();
  if (!temp.equals("")) passwd = temp;

  
  System.out.println("Connection information:\n");
  System.out.println("\tURL is " + url + " \n");
  System.out.println("\tDriver is " + driver + "\n");
  System.out.println("\tLogin is " + login + "\n");
  System.out.println("\tPassword is " + passwd + "\n");

  DB2net1 session = new DB2net1();
 }

 public DB2net1() throws IOException
 {
  try {
   Class.forName(driver);
   curConn = DriverManager.getConnection(url, login, passwd);
   checkForWarnings(curConn.getWarnings ());
  }
  catch(java.lang.Exception ex) {
   System.out.println("url    : " + url);
   System.out.println("login  : " + login);
   System.out.println("passwd : " + passwd);
   ex.printStackTrace();
   return;
  }
  processQueries();
  finalize();
 }

 protected void finalize()
 {
  try {
   curConn.close();
  } catch (SQLException ex) { }
 }

 private void processQueries() throws IOException
 {
  int i = 1;
  String temp = "";
  String query = "";
  String results = "";

  System.out.println("Type 'quit' on a blank line to exit, or 'go' to execute the query.");
  do {
   System.out.print(i + "> ");
   System.out.flush();
   temp = kbd.readLine();
   if (temp.equals("quit"))
    break;
   if (temp.equals("go")) {
    executeThisQuery(query);
    i = 1;
    query = "";
   }
   else {
    query = query + " " + temp;
    i++;
   }
  } while (0 == 0);
 }

 private void executeThisQuery(String sqlText)
 {
  boolean resultSetIsAvailable;
  boolean moreResultsAvailable;
  int i = 0;
  int res=0;
  try {
   Statement curStmt = curConn.createStatement();
   resultSetIsAvailable = curStmt.execute(sqlText);
   ResultSet rs = null;
    for (moreResultsAvailable = true; moreResultsAvailable; )
   {
    checkForWarnings(curConn.getWarnings());
     if (resultSetIsAvailable)
    {
     if ((rs = curStmt.getResultSet()) != null)
      {
      // we have a resultset
      checkForWarnings(curStmt.getWarnings());
      ResultSetMetaData rsmd = rs.getMetaData();
      int numCols = rsmd.getColumnCount();

      // display column headers
      for (i = 1; i <= numCols; i++)
      {
       if (i > 1) System.out.print(", ");
       System.out.print(rsmd.getColumnLabel(i));
      }
      System.out.println("");

      // step through the rows
      while (rs.next())
      {
       // process the columns
       for (i = 1; i <= numCols; i++)
       {
        if (i > 1) System.out.print(", ");
        System.out.print(rs.getString(i));
       }
       System.out.println("");
      }
     }
    }
    else
    {
     if ((res = curStmt.getUpdateCount()) != -1)
     {
      // we have an updatecount
      System.out.println(res + " row(s) affected.");
     }
     // else no more results
     else
     {
      moreResultsAvailable = false;
     }
     }
    if (moreResultsAvailable)
    {
     resultSetIsAvailable = curStmt.getMoreResults();
    }
   }
   if (rs != null) rs.close();
   curStmt.close();
  }
  catch (SQLException ex) {

   // Unexpected SQL exception.
   ex.printStackTrace ();
  }
  catch (java.lang.Exception ex) {

   // Got some other type of exception.  Dump it.
   ex.printStackTrace ();
  }
 }

 private static void checkForWarnings (SQLWarning warn)
   throws SQLException
 {
  while (warn != null) {
   System.out.println(warn);
   warn = warn.getNextWarning();
  }
 }
}

